
renoise.tool():add_menu_entry {
  name = "Pattern Sequencer:List Unused Patterns",
  invoke = function() main() end
    
}


--helper function : custom status message --prefixes tool name and adds brackets 
--------------------------------------------------------------------------------
function status(message)
------------------------
  renoise.app():show_status("List Unused Patterns Tool: ("..message..")")
end
---


g_sequencer_state = {}
g_unused_pats_state = {}
--true when pattern seq changes or pattern assignments change sequencer
g_notifier_flag= false


--takes a table of patterns that are unused in the song
--and returns a string format for the main multiline textfield output
-----------------------------------------
function unused_tab_to_string(unused_tab)
-----------------------------------------

  local string = ""
  local song = renoise.song()
  
  for i = 1,#unused_tab do
    local pat_idx = unused_tab[i]
    string = string.."\n  "..tostring(pat_idx-1)
    if song:pattern(pat_idx).is_empty == true then
      string = string.."  (empty)"
    end
  end
  
  local prefix = ""
  if string == "" then
    prefix = "\n     NO UNUSED PATTERNS FOUND"
  else
    prefix = "\n     UNUSED PATTERNS:\n"  
  end
  
  return string

end
---



----------------------
function list_unused()
----------------------
  
  local song = renoise.song()
  local string = ""
  
  local sequence = song.sequencer.pattern_sequence
  
  --example sequence (off by +1 for both index and pattern no.)
  -- [1] =>  1
  -- [2] =>  2
  -- [3] =>  2
  -- [4] =>  4
  
  
 -- rprint(sequence)
  local unused_tab = {}
  unused_tab.patterns = {}
  local counter = 0
  
  --loop patterns
  for i = 1,#song.patterns do
    local found = false
    --loop 2 sequence
    for j = 1,#sequence do
      --method access to pattern index (same as song.sequencer.pattern_sequence[j])(but faster?)
      if i == song.sequencer:pattern(j) then
        found = true
      end
    end
    --add to unused patterns
    if found == false then
      counter = counter + 1
      unused_tab.patterns[counter] = (i)
    end
  end 

  --add string to return table
  unused_tab.string = unused_tab_to_string(unused_tab.patterns)
  return unused_tab
end



local my_dialog  = nil
local vb = nil

-------------------------------
function main()
-------------------------------
  
  
  --refresh dialog 
  if (my_dialog and my_dialog.visible) then 
    my_dialog:close()
  end
  
  my_dialog = nil 
  vb = nil
  
  --renoise song object
  local song = renoise.song()
  
  
  --get initial sequencer state for globals (checked against in timer fn)
  -----------------------------------------------------------------------
  local num_seq = #song.sequencer.pattern_sequence
  for i = 1,num_seq do
    g_sequencer_state[i] = song.sequencer:pattern(i)
  end
  
  g_unused_pats_state = list_unused().patterns
  
    
  --set globals
  -------------
  --viewbuilder instance
  vb = renoise.ViewBuilder()
  

  
  ----------------------------------------------
  --GUI
  ----------------------------------------------     

  --variables that will be added to
  --dialog_content:add_child(send_row)
  local my_first_row = vb:column{}
  -------------------------------
  local my_first_element = nil
  

    my_first_element = vb:column{
                        margin = 2,
                         vb:row{
                          margin = 4,
                          
                          vb:button{
                           text = "Re-Check",
                           notifier = function()
                                        --update readout string
                                        vb.views["readout string"].text = list_unused().string--get_doubled_instruments()--get_doubled_devices()
                                        --
                                        status("List Updated")
                                        
                                      end
                          },
                          
                          vb:text{
                           width = 118,
                          },
                         
                          vb:button{
                            text = "Add Non-Empty To End",
                            notifier = function()
                                          local song = renoise.song()
                                          --get table of unused pattern indexes
                                          local unused_pats = list_unused().patterns
                                          --last pos in sequencer
                                          local last_pos = #song.sequencer.pattern_sequence
                                          local idx_string = "" 
                                          local pos_string = ""
                                          --loop unused patterns table
                                          for i = #unused_pats,1,-1 do
                                            local idx = unused_pats[i]
                                            --add non-empty to sequencer
                                            if song:pattern(idx).is_empty == false then
                                              renoise.song().sequencer:insert_sequence_at(last_pos+1, idx)
                                              idx_string = idx_string..tostring(idx-1)..", "
                                              pos_string = tostring(last_pos)
                                            end
                                          end
                                          --status and select first of new patterns added to sequencer
                                          if idx_string ~= "" then
                                            status("Patterns "..idx_string.."Added To Sequencer Starting at pos: "..pos_string)
                                            song.selected_sequence_index = last_pos + 1
                                          end
                                          --update gui
                                         -- vb.views["readout string"].text = list_unused().string
                                        end
                          }, 
                        
                         },
                        vb:multiline_textfield { 
                         id = "readout string",
                         width = 310,
                         height = 300,
                         text = list_unused().string --get_doubled_instruments()--get_doubled_devices()
                        }
                       }


    my_first_row:add_child(my_first_element) 
  

  
  --------------------------------------------------------
  --------------------------------------------------------
  --dialog content will contain all of gui; passed to renoise.app():show_custom_dialog()
  local dialog_content = vb:column{}
  dialog_content:add_child(my_first_row)
 
  --------------
  --key Handler
  --------------
  local function my_keyhandler_func(dialog,key)
     --toggle lock focus hack, allows pattern ed to get key input
     renoise.app().window.lock_keyboard_focus = not renoise.app().window.lock_keyboard_focus
     renoise.app().window.lock_keyboard_focus = not renoise.app().window.lock_keyboard_focus
     return key
  end 
  
 
  ------------------------------------------------------------------------------------------
  ------------------------------------------------------------------------------------------
  --Script dialog
  my_dialog = renoise.app():show_custom_dialog(
      "Unused Patterns In Sequencer", dialog_content,my_keyhandler_func)

 
  --timers and notifiers
  ----------------------
 
  --add timer to fire once every 50ms
  if not renoise.tool():has_timer(timer) then
    renoise.tool():add_timer(timer,80)
  end
  
  -----------------------------------   
  --close dialog function ON NEW SONG
  -----------------------------------
  local function closer(d)
    --close dialog if exists and is open     
    if (d ~= nil) and (d.visible == true) then
      d:close()
     -- remove_notifiers()
    end
    --reset global my_dialog
     my_dialog = nil 
  end 
  
  --notifier to close dialog on load new song 
  renoise.tool().app_release_document_observable:add_notifier(closer,my_dialog)
  
    
  --notifiers to update flag when pattern sequence changes (this flag is checked in timer function)
  if song.sequencer.pattern_sequence_observable:has_notifier(notifier_flag_to_true) == false then
    song.sequencer.pattern_sequence_observable:add_notifier(notifier_flag_to_true)
  end
  if song.sequencer.pattern_assignments_observable:has_notifier(notifier_flag_to_true) == false then
    song.sequencer.pattern_assignments_observable:add_notifier(notifier_flag_to_true)
  end
  
  --first run of timer
  timer()

end
---

--added to notifiers watching the sequencer for changes
---------------------------------------
function notifier_flag_to_true()
---------------------------------------
  g_notifier_flag= true
end


--timer function
----------------
function timer()
----------------

  local song = renoise.song()
  
  --remove timer when GUI is closed
  if(my_dialog == nil) or (my_dialog.visible == false) then
    if renoise.tool():has_timer(timer) then
      renoise.tool():remove_timer(timer)
    end
    --remove notifiers
    if song.sequencer.pattern_sequence_observable:has_notifier(notifier_flag_to_true) == true then
      song.sequencer.pattern_sequence_observable:remove_notifier(notifier_flag_to_true)
      --print("removed")
    end
    if song.sequencer.pattern_assignments_observable:has_notifier(notifier_flag_to_true) == true then
      song.sequencer.pattern_assignments_observable:remove_notifier(notifier_flag_to_true)
      --print("removed")
    end
    return
  end
  
  local song = renoise.song()
  local state_changed = g_notifier_flag --true when sequencer notifiers hit
  
  --check if the unused patterns state changed (the patterns listed by the tool)
  --no notifiers available for this so have to check manually here
  ------------------------------------------------------------------------------
  local cur_unused = list_unused().patterns
  --check length of unused patterns table 
  if state_changed == false then
    if #g_unused_pats_state ~= #cur_unused then
      --print("unused pats changed")
      state_changed = true
    end
  end
  --check contents of unused patterns table
  if state_changed == false then
    for i = 1,#cur_unused do
      if g_unused_pats_state[i] ~= cur_unused[i] then
       -- print("unused patterns state changed")
      end
    end
  end
  
  --if state did change, update readout and globals to new states
  ---------------------------------------------------------------
  if state_changed == true then
    local list = list_unused()
    vb.views["readout string"].text = list.string
    --update globals
    g_sequencer_state = song.sequencer.pattern_sequence
    g_unused_pats_state = list.patterns
    --print("updated")
  end
  
  --reset global-notifier_flag
  g_notifier_flag = false
  
end


